%%  Definici\'o de l'estil del Butllet\'\i
%%  de la Societat Catalana de Matem\`atiques
%%  en LaTeX(2e). Versi\'o 2.6.
%%
%%  Si us plau, no modifiqueu aquest fitxer sota cap concepte.
%% 
%%
%%  Versi\'o 1.0, Jos\'e Luis Ruiz 4/96. v.1.1: 9/96. v.1.2: 5/97. 
%%
%%  Versi\'o 2.0, Josep M. Font, 15.11.05. Canvis marcats amb %+.
%%  Versi\'o 2.1, Josep M. Font, 15.03.06. Canvis marcats amb %++.
%%  Versi\'o 2.2, Josep M. Font, 23.04.07. Canvis marcats amb %+++.
%%  Versi\'o 2.3, Josep M. Font, 12.10.07. Canvis marcats amb %++++.
%%  Versi\'o 2.4, Josep M. Font, 21.09.09. Canvis marcats amb %-.
%%  Versi\'o 2.5, Josep M. Font, 19.03.11. Canvis marcats amb %--.
%%  Versi\'o 2.6, Josep M. Font, 06.05.12. Canvis marcats amb %---.
%%
\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{scmbut2}[2012/05/06 v2.6 Butlleti de la SCM]     %-

\DeclareOption{titlepage}{\ClassError{Option not supported}{'titlepage'}} %+
\DeclareOption{twocolumn}{\ClassError{Option not supported}{'twocolumn'}} %+
\DeclareOption{a5paper}{\ClassError{Option not supported}{'a5paper'}} %+
\DeclareOption{b5paper}{\ClassError{Option not supported}{'b5paper'}} %+
\DeclareOption{letterpaper}{\ClassError{Option not supported}{'letterpaper'}} %+
\DeclareOption{legalpaper}{\ClassError{Option not supported}{'legalpaper'}} %+
\DeclareOption{executivepaper}{\ClassError{Option not supported}{'executivepaper'}} %+
\DeclareOption{landscape}{\ClassError{Option not supported}{'landscape'}} %+
\DeclareOption{leqno}{\ClassError{Option not supported}{'leqno'}} %+
\DeclareOption{fleqn}{\ClassError{Option not supported}{'fleqn'}} %+

\newif\if@preprint
\DeclareOption{preprint}{\global\@preprinttrue}
\DeclareOption{nopreprint}{\global\@preprintfalse}

\DeclareOption*{\PassOptionsToClass{\CurrentOption}{article}} %+
\ExecuteOptions{nopreprint}
\ProcessOptions
\LoadClass[a4paper,10pt,twoside,onecolumn,final]{article}
\RequirePackage{fixltx2e}                        %+++

\RequirePackage{amsmath}                         %+       
\RequirePackage[catalan]{babel}                  %+

\if@preprint                                     %+
  \RequirePackage{amssymb,latexsym}              %+++
\else
  \RequirePackage[LY1]{fontenc}                  %+ %--- LY1 en comptes de T1, eliminat "textcomp"
  \RequirePackage[expert,vargreek,altbullet]{lucidabr}   %+++
  \RequirePackage{latexsym}                              %+++
\fi

\RequirePackage{microtype}                                           %+++ %-- canviat de lloc
\def\MT@register@subst@font{\MT@exp@one@n\MT@in@clist\font@name\MT@font@list %--  correcci
\ifMT@inlist@\else\xdef\MT@font@list{\MT@font@list\font@name,}\fi}           %--  correcci


\setlength{\textwidth}     {12.6cm}
\setlength{\oddsidemargin} {1.71cm}
\setlength{\evensidemargin}{1.71cm}
\setlength{\topmargin}     {0.2cm} 
\setlength{\headheight}    {1.2cm} 
\setlength{\headsep}       {1cm}   
\setlength{\textheight}    {19cm}  

\frenchspacing

\newcounter{Fpage}      
\newcounter{Lpage}        
\def\@titol{}
\def\@stitol{}
\def\@autor{}
\def\@sautor{}
\def\@afil{}
\def\title#1{%
  \ifx#1[
    \let\next\@@titol
  \else
    \def\next{\gdef\@titol{#1}\gdef\@stitol{#1}}
  \fi
  \next
}
\def\@@titol#1]#2{\gdef\@titol{#2}\gdef\@stitol{#1}}
\def\author#1{%
  \ifx#1[
    \let\next\@@autor
  \else
    \def\next{\gdef\@autor{#1}\gdef\@sautor{#1}}
   \fi
   \next
}
\def\@@autor#1]#2{\gdef\@autor{#2}\gdef\@sautor{#1}}
\def\afil#1{\gdef\@afil{#1}}
\def\email#1{{\normalfont\texttt{#1}}}

\newcommand{\volum}[1]{\gdef\@volum{#1}}
\newcommand{\numero}[1]{\gdef\@numero{#1}}
\newcommand{\any}[1]{\gdef\@any{#1}}                                 %+
\newcommand{\pagines}[2]{%
  \setcounter{page}{#1}
  \setcounter{Fpage}{#1}                         
  \setcounter{Lpage}{#2}}  
\begingroup                                                          %++++
\catcode`\Q=3                                                        %++++
\long\gdef\@ifmtarg#1{\@xifmtarg#1QQ\@secondoftwo\@firstoftwo\@nil}  %++++
\long\gdef\@xifmtarg#1#2Q#3#4#5\@nil{#4}                             %++++
\long\gdef\@ifnotmtarg#1{\@xifmtarg#1QQ\@firstofone\@gobble\@nil}    %++++
\endgroup                                                            %++++
\newcommand{\doi}[1]{\gdef\@doi{\@ifmtarg{#1}{}%                     %++++
                 {.~~{\footnotesize DOI:~#1}}}}                      %++++
\AtBeginDocument{\@ifundefined{@doi}{\ClassError{Command undefined}{DOI}%-
{Falta la comanda que fixa el 'doi', al final del preamble.\MessageBreak %-  Info
Probablement has pres com a model un fitxer massa antic.\MessageBreak    %-  per al
Baixa't el ms recent de la web de la SCM.}\gdef\@doi\relax}{}}          %-  help                           

\renewcommand{\maketitle}{%
  \par\thispagestyle{empty}
  \begingroup
    \renewcommand\thefootnote{}%-- Eliminat smbol de nota a la primera pgina:
%    \def\@makefnmark{\rlap{\@textsuperscript{\normalfont\@thefnmark}}}%--
    \long\def\@makefntext##1{%
      \parindent1em\noindent
      %\hb@xt@1.8em{\hss\raise 1pt\hbox{\normalfont\@thefnmark\ }} %-- Idem
      ##1}
    \newpage
    \global\@topnum\z@
    \@maketitle
    \@thanks
  \endgroup
  \setcounter{footnote}{0}%
  \let\thanks\relax
  \let\maketitle\relax\let\@maketitle\relax
  \gdef\@thanks{}\gdef\author{}\gdef\title{}}

\let\and=\relax
\def\@maketitle{%
  \let\footnote\thanks
  \newpage
  \vspace*{-1.64\headsep}                                                 %+++
  \vbox to 0.35\textheight{\parindent\z@
    {\small\noindent
     \textsc{Butllet\'\i{} de la Societat Catalana de Matem\`atiques}\\
     Vol.~\@volum,\space n\'um.~\@numero,\space \@any.                    %+
     \ifnum\value{Fpage}=\value{Lpage}P\`ag.~\theFpage\else%              %++
     P\`ag.~\theFpage--\theLpage\fi\@doi}                                 %++++
    \vspace{4ex}                                                          %+++
    \begin{flushleft}%
      {\Large\normalfont\sffamily\bfseries\@titol\par}%
      \vskip 1.5ex%
%      \addtocounter{footnote}{5}%                                         %++ %-- ja no cal
      {\normalsize\normalfont\scshape\@autor\par}%
    \end{flushleft}%
    \par\vfill}}

\AtBeginDocument{\maketitle\let\maketitle\relax}
\AtEndDocument{%
  \@ifundefined{@afil}{\relax}{\par\vspace{4ex}
     \begin{flushleft}\normalfont\scshape\@afil\end{flushleft}}}
  
\renewcommand{\@makefntext}[1]{%                                          %+
      \parindent1em\noindent
      \hb@xt@1.8em{\hss\hbox{\normalfont\@thefnmark\ }}#1}   

\def\ps@myheadings{%
 \let\@oddfoot\@empty\let\@evenfoot\@empty
 \def\@oddhead{\hphantom{\thepage}\hss{\itshape\@stitol}\hss\thepage}%
 \def\@evenhead{\thepage\hss{\itshape\@sautor}\hss\hphantom{\thepage}}}
\pagestyle{myheadings}

\renewcommand\section{\@startsection
  {section}{1}{\z@}{-3.5ex \@plus -0.5ex \@minus -.2ex}%
  {1.5ex \@plus .2ex}{\normalfont\raggedright\large\sffamily\bfseries}}
\renewcommand\subsection{\@startsection
  {subsection}{2}{\z@}{-3ex\@plus-0.5ex \@minus-0.2ex}%
  {1ex \@plus .2ex}{\normalfont\raggedright\normalsize\sffamily\bfseries}}
\renewcommand\subsubsection{\@startsection
  {subsubsection}{3}{\z@}{3ex \@plus -0.5ex\@minus -0.2ex}%
  {-1em}{\normalfont\normalsize\sffamily\bfseries}}
\renewcommand\paragraph{\@startsection
  {paragraph}{4}{\z@}{3ex \@plus0.5ex \@minus.2ex}%
  {-1em}{\normalfont\normalsize\itshape}}
\renewcommand\subparagraph{\@startsection
  {subparagraph}{5}{\parindent}{3ex \@plus0.5ex \@minus .2ex}%
  {-1em}{\normalfont\normalsize\itshape}}

\def\@listi{%
  \leftmargin\leftmargini
  \parsep  0.5ex \@plus0.1ex\@minus0.1ex
  \topsep  1ex \@plus0.2ex\@minus0.2ex                    %+++
  \itemsep \z@ \@plus0.1ex}
\let\@listI\@listi
\@listi
\def\@listii{%
  \leftmargin\leftmarginii
  \labelwidth\leftmarginii
  \advance\labelwidth-\labelsep
  \topsep    4\p@ \@plus2\p@ \@minus\p@
  \parsep    2\p@ \@plus\p@  \@minus\p@
  \itemsep   \parsep}
\def\@listiii{%
  \leftmargin\leftmarginiii
  \labelwidth\leftmarginiii
  \advance\labelwidth-\labelsep
  \topsep    2\p@ \@plus\p@\@minus\p@
  \parsep    \z@
  \partopsep \p@ \@plus\z@ \@minus\p@
  \itemsep   \topsep}
\def\@listiv{%
  \leftmargin\leftmarginiv
  \labelwidth\leftmarginiv
  \advance\labelwidth-\labelsep}
\def\@listv{%
  \leftmargin\leftmarginv
  \labelwidth\leftmarginv
  \advance\labelwidth-\labelsep}
\def\@listvi{%
  \leftmargin\leftmarginvi
  \labelwidth\leftmarginvi
  \advance\labelwidth-\labelsep}

\newlength{\normalparindent}
\setlength{\normalparindent}{\parindent}

\renewcommand\labelenumii{\theenumii)}
\renewcommand\p@enumiii{\theenumi\theenumii)}

\renewenvironment{quotation}                       %+++
  {\list{}{\listparindent\normalparindent
           \itemindent\normalparindent
           \leftmargin\normalparindent
           \rightmargin\normalparindent           
           \parsep\z@\@plus\p@}%
           \item\relax}{\endlist}
\let\quote\quotation                               %+++
\let\endquote\endquotation                         %+++

\newenvironment{resum}
  {\subsubsection*{Resum:}\small}{\par\vspace{5ex \@plus.5ex\@minus.5ex}}     %+%--
\renewenvironment{abstract}  
  {\subsubsection*{Abstract:}\small}{\par\vspace{5ex \@plus.5ex\@minus.5ex}}  %+%--
  
\newcommand{\paraulesclau}[1]{%                                              %+
\par\medskip\noindent{\normalsize\sffamily Paraules clau:} #1}               

\newcommand{\classificacio}[1]{%                                             %-
\par\medskip\noindent{\normalsize\sffamily Classificaci\'o MSC2010:} #1}     %-

\newenvironment{cita}[1]                                                     %+
  {\xdef\autorcita{ #1}
   \leftskip=0.5\textwidth
   \parindent=0pt                               
   \small\sffamily}
  {\par \vspace{-0.3\baselineskip}                                           %+++
  \begin{flushright}\bfseries\autorcita\end{flushright}
    \vspace{\baselineskip}                                     
  \xdef\autorcita{}}
    
\newcommand{\agraiments}[1]{\addvspace{5ex}\subsection*{Agra\"{\i}ments} #1}  %+  

\renewcommand{\tableofcontents}{\relax}
\renewcommand{\listoffigures}{\relax}
\renewcommand{\listoftables}{\relax}

\RequirePackage[amsmath,thmmarks]{ntheorem}                                  %+  

\theoremheaderfont{\normalfont\scshape}
\theoremnumbering{arabic}
\theoremseparator{.}                            %-- El punt
\theoremsymbol{}
\qedsymbol{\ensuremath{\Box}}                                     
\setlength{\theorempreskipamount}{2ex \@plus.5ex\@minus.5ex}  
\setlength{\theorempostskipamount}{1ex \@plus.5ex\@minus.5ex} 

\theoremstyle{plain}                            %-- El nmero darrera del nom
\theorembodyfont{\normalfont\itshape}
\newtheorem{teor}{Teorema}
\newtheorem{lema}[teor]{Lema}
\newtheorem{prop}[teor]{Proposici\'o}
\newtheorem{coro}[teor]{Coro\l.lari}
\newtheorem{cors}[teor]{Coro\l.laris}
\theorembodyfont{\normalfont}                   %+++
\newtheorem{defi}[teor]{Definici\'o}
\newtheorem{conj}[teor]{Conjectura}
\newtheorem{prob}[teor]{Problema}

\theoremstyle{nonumberplain}
\theorembodyfont{\normalfont}                                
\newtheorem{exem}{Exemple}
\newtheorem{exms}{Exemples}
\newtheorem{exer}{Exercici}
\newtheorem{exrs}{Exercicis}
\newtheorem{cont}{Contraexemple}
\newtheorem{obse}{Observaci\'o}
\newtheorem{nota}{Nota}
\newtheorem{fett}{Fet}
\newtheorem{enun}{Enunciat}                      %++ 

\newenvironment{enunciat}[1]{%                   %++
  \theoremstyle{nonumberplain}
  \theorembodyfont{\normalfont\itshape}
  \renewtheorem{enun}{#1}\begin{enun}}%
  {\end{enun}}

\newtheorem{preprova}{PreProva}                       %-- nova "prova", que
\newenvironment{prova}[1][Prova]{%                    %-- admet argument opcional                                  
  \theoremstyle{nonumberplain}                        %--
  \theorembodyfont{\normalfont}                       %--
  \theoremsymbol{\ensuremath{\Box}}                   %--       
  \theoremprework{\vspace{-.5\theorempreskipamount}}  %-- 
  \renewtheorem{preprova}{#1}\begin{preprova}}        %--
  {\end{preprova}}                                    %--

\theoremsymbol{}                     

\def\caption{\refstepcounter\@captype\@dblarg{\@caption\@captype}}     %+
\long\def\@caption#1[#2]#3{%
  \par                                     
  \begingroup
    \@parboxrestore
    \if@minipage
      \@setminipage
    \fi
    \normalsize
    \@makecaption{{\small\textsc{\csname fnum@#1\endcsname}}}%
     {\ignorespaces{\small #3}}\par
    \endgroup}
\long\def\@makecaption#1#2{%                                          %++
  \vskip\abovecaptionskip
  \newdimen\@captionwidth\newdimen\@captionmargin
  \advance\@captionmargin by 2\normalparindent 
  \advance\@captionwidth by \hsize
  \advance\@captionwidth by -2\@captionmargin
  \sbox\@tempboxa{#1: #2}%     
  \newbox\@tempboxb\sbox\@tempboxb{#2}% 
  \ifdim \wd\@tempboxa >\@captionwidth     
   \mbox{}\hskip\@captionmargin\begin{minipage}{\@captionwidth}
    #1: #2                 
   \end{minipage}
  \else
    \global\@minipagefalse
    \ifdim \wd\@tempboxb = 0pt\hb@xt@\hsize{\hfil#1\hfil}%            
    \else  
    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
    \fi  
  \fi
  \vskip\belowcaptionskip}
      
% modificaci de la \lgem i \Lgem de babel:               %+

\def\lgem{%
  \ifmmode
    \csname normal@char\string"\endcsname l%
  \else
    \leftllkern=0pt\rightllkern=0pt\raiselldim=0pt%
    \setbox0\hbox{l}\setbox1\hbox{l\/}\setbox2\hbox{.}%
    \setbox3\hbox{x}%                                      
    \ifdim\ht3=\ht0%                                       
      \advance\raiselldim by .5\ht0%                       
      \advance\raiselldim by -.5\ht2%                      
    \else                                                  
      \advance\raiselldim by \the\fontdimen5\the\font%     
      \advance\raiselldim by -1.5\ht2%                          
    \fi%                                                                 
    \leftllkern=-.25\wd0%
    \advance\leftllkern by \wd1%        
    \advance\leftllkern by -\wd0%
    \advance\leftllkern by -\the\fontdimen1\the\font%          
    \advance\leftllkern by -\the\fontdimen1\the\font%          
    \rightllkern=-.25\wd0%
    \advance\rightllkern by -\wd1%
    \advance\rightllkern by \wd0%
    \advance\rightllkern by \the\fontdimen1\the\font%          
    \allowhyphens\discretionary{l-}{l}%
    {\hbox{l}\kern\leftllkern\raise\raiselldim\hbox{.}%
      \kern\rightllkern\hbox{l}}\allowhyphens
  \fi
  }
\def\Lgem{%
  \ifmmode
    \csname normal@char\string"\endcsname L%
  \else
    \leftllkern=0pt\rightllkern=0pt\raiselldim=0pt%
    \setbox0\hbox{L}\setbox1\hbox{L\/}\setbox2\hbox{.}%
    \advance\raiselldim by .5\ht0%
    \advance\raiselldim by -.5\ht2%
    \leftllkern=-.125\wd0%
    \advance\leftllkern by \wd1%
    \advance\leftllkern by -\wd0%
    \rightllkern=-\wd0%
    \divide\rightllkern by 6%
    \advance\rightllkern by -\wd1%
    \advance\rightllkern by \wd0%
    \advance\rightllkern by -\the\fontdimen1\the\font%         
    \advance\rightllkern by -\the\fontdimen1\the\font%         
    \allowhyphens\discretionary{L-}{L}%
    {\hbox{L}\kern\leftllkern\raise\raiselldim\hbox{.}%
      \kern\rightllkern\hbox{L}}\allowhyphens
  \fi
  }
        
%  diversos macros tils

\newenvironment{spmatrix}{\left(\begin{smallmatrix}}          
  {\end{smallmatrix}\right)}
\newcommand{\gills}[1]{\guillemotleft{}#1{}\guillemotright}   %+ 
\newcommand{\Ndash}{\nobreakdash--}  
\newcommand{\guio}[1]{\nobreakdash-\hspace{0pt}#1}    
\def\quotedfrom #1{{\unskip\nobreak\hfil\penalty50            %++
  \hskip2em\hbox{}\nobreak\hfil #1\parfillskip=0pt 
  \finalhyphendemerits=0 \par}}
\newcommand{\interitemtext}[1]{\item[] \hspace{-25.5pt} #1}

\endinput
